/*
 * Copyright  2004-2005 AIRG.
 *
 *
 */
package testxmlsec;



import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.*;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;

import org.apache.xml.security.signature.XMLSignature;
import org.apache.xml.security.transforms.Transforms;
import org.apache.xml.security.transforms.params.XPathContainer;
import org.apache.xml.security.utils.Constants;
import org.apache.xml.security.utils.XMLUtils;
import org.w3c.dom.Element;

import org.aaauthreach.resources.ConfigSecurity;
import org.aaauthreach.utils.*;

/**
 *
 *
 * @author $Author: demch $
 */
public class TestIODEF02SignTypes {

   /** {@link org.apache.commons.logging} logging facility */
   // static org.apache.commons.logging.Log log = 
   //     org.apache.commons.logging.LogFactory.getLog(CreateSignature.class.getName());
 	
/////////////// Create a simple document and sign with the Enveloped Signature

 	public static void CreateAndSignDoc (List keyset, String uri2sign, String xpath2sign) throws Exception {

 		String savefile = "iodef40test01.xml";
 		File signedFile = new File("signed-" + savefile);
        
  	    String keystoreType = (String) keyset.get(0);
  	    String keystoreFile = (String) keyset.get(1);
  	    String keystorePass = (String) keyset.get(2);
  	    String privateKeyAlias = (String) keyset.get(3);
  	    String privateKeyPass = (String) keyset.get(4);
  	    String certificateAlias = (String) keyset.get(5);

        //J+
        KeyStore ks = KeyStore.getInstance(keystoreType);
        FileInputStream fis = new FileInputStream(keystoreFile);

        ////FileOutputStream fus = new FileOutputStream(outFile);
        ////System.out.print(fis.toString());
        
        //load the keystore
        ks.load(fis, keystorePass.toCharArray());

        //get the private key for signing.
        PrivateKey privateKey = (PrivateKey) ks.getKey(privateKeyAlias,
                                               privateKeyPass.toCharArray());
         //System.out.print("\n###Private key: \n" + privateKey.toString()); //***
        
        
      //Build a sample document. It will look something like:
      /*
       <!-- Comment before -->
       <iodef:IODEF-Document xmlns:iodef="http://www.aaauthreach.org/ns/#iodef" version="0.4">
         <iodef:Incident Id="incident" purpose="handling" restriction="default">
           <iodef:IncidentID name="DOMCERT" restriction="default">DOMCERT-2004-12-12-opsec-007
           </iodef:IncidentID>
           <iodef:Description>This a test Incident description
           </iodef:Description>
           <iodef:Contact contactrole="creator" contacttype="person">
             <iodef:Name lang="en-uk" preserve="no" transform="none">Jason Mann
             </iodef:Name>
           </iodef:Contact>
           <iodef:ReportTime>2004-12-22T22:22:22Z</iodef:ReportTime>
           <iodef:Assessment restriction="default">
             <iodef:Impact completion="fail" impacttype="unknown" lang="en-uk" severity="low"></iodef:Impact>
           </iodef:Assessment>
           <iodef:EventData Id="eventdata" restriction="default">
             <iodef:System interface="interface@system" restriction="default" spoofed="no" systemcat="source">
               <iodef:Node nodetype="unknown">
                 <iodef:Address addrcat="ipv4-addr" vlan-name="VLAN" vlan-num="311">212.34.56.22</iodef:Address>
               </iodef:Node>
             </iodef:System>
           </iodef:EventData>
         </iodef:Incident>
       </iodef:IODEF-Document>
       <!-- Comment after -->
         */

      // start xml document part
      javax.xml.parsers.DocumentBuilderFactory dbf =
         javax.xml.parsers.DocumentBuilderFactory.newInstance();

      //XML Signature needs to be namespace aware
      dbf.setNamespaceAware(true);

      javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder();
      // reading document
      org.w3c.dom.Document doc = db.newDocument();

      //XMLUtils.outputDOMc14nWithComments(doc2, f1);
      
      doc.appendChild(doc.createComment(" Comment before "));
      // root element is IODEF-Document
      Element root = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef",
                                         "iodef:IODEF-Document");

      root.setAttributeNS(null, "version", "0.4");
      root.appendChild(doc.createTextNode("\n"));
      root.setAttributeNS(Constants.NamespaceSpecNS, "xmlns:iodef", "http://www.aaauthreach.org/ns/#iodef");
      doc.appendChild(root);

      Element incident = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Incident");
      incident.setAttribute("Id", "incident");
      incident.setAttribute("restriction", "default");
      incident.setAttribute("purpose", "handling");
      incident.appendChild(doc.createTextNode("\n"));
      root.appendChild(incident);
      root.appendChild(doc.createTextNode("\n"));
      		
      Element incidentID = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:IncidentID");
      incidentID.appendChild(doc.createTextNode("DOMCERT-2004-12-12-opsec-007\n"));
      incidentID.setAttribute("restriction", "default");
      incidentID.setAttribute("name", "DOMCERT");
      incident.appendChild(incidentID);
      incident.appendChild(doc.createTextNode("\n"));

      Element description = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Description");
      description.appendChild(doc.createTextNode("This a test Incident description\n"));
      incident.appendChild(description);
      incident.appendChild(doc.createTextNode("\n"));

      Element contact = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Contact");
      contact.setAttribute("contactrole", "creator");
      contact.setAttribute("contacttype", "person");
      contact.appendChild(doc.createTextNode("\n"));
      incident.appendChild(contact);
      incident.appendChild(doc.createTextNode("\n"));

      Element namecontact = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Name");
      namecontact.appendChild(doc.createTextNode("Jason Mann"));
      namecontact.setAttribute("lang", "en-uk");
      namecontact.setAttribute("preserve", "no");
      namecontact.setAttribute("transform", "none");
      contact.appendChild(namecontact);
      contact.appendChild(doc.createTextNode("\n"));

      Element reporttime = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:ReportTime");
      //Date reportT = new Date();
      String reportT = "2004-12-22T22:22:22Z"; 
      reporttime.appendChild(doc.createTextNode(reportT));
      incident.appendChild(reporttime);
      incident.appendChild(doc.createTextNode("\n"));

      Element assessment = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Assessment");
      assessment.setAttribute("restriction", "default");
      assessment.appendChild(doc.createTextNode("\n"));
      incident.appendChild(assessment);
      incident.appendChild(doc.createTextNode("\n"));

      Element impact = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Impact");
      impact.setAttribute("severity", "low");
      impact.setAttribute("completion", "fail");
      impact.setAttribute("impacttype", "unknown");
      impact.setAttribute("lang", "en-uk");
      assessment.appendChild(impact);
      assessment.appendChild(doc.createTextNode("\n"));

      Element eventdata = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:EventData");
      eventdata.setAttribute("Id", "eventdata");
      eventdata.setAttribute("restriction", "default");
      eventdata.appendChild(doc.createTextNode("\n"));
      incident.appendChild(eventdata);
      incident.appendChild(doc.createTextNode("\n"));

      Element system = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:System");
      system.setAttribute("restriction", "default");
      system.setAttribute("interface", "interface@system");
      system.setAttribute("systemcat", "source");
      system.setAttribute("spoofed", "no");
      system.appendChild(doc.createTextNode("\n"));
      eventdata.appendChild(system);
      eventdata.appendChild(doc.createTextNode("\n"));

      Element node = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Node");
      node.setAttribute("nodetype", "unknown");
      node.appendChild(doc.createTextNode("\n"));
      system.appendChild(node);
      system.appendChild(doc.createTextNode("\n"));

      Element address = doc.createElementNS("http://www.aaauthreach.org/ns/#iodef", "iodef:Address");
      address.appendChild(doc.createTextNode("212.34.56.22"));
      address.setAttribute("addrcat", "ipv4-addr");
      address.setAttribute("vlan-name", "VLAN");
      address.setAttribute("vlan-num", "311");
      node.appendChild(address);
      //address.appendChild(doc.createTextNode("\n"));
      node.appendChild(doc.createTextNode("\n"));

      doc.appendChild(doc.createComment(" Comment after "));
      // end of document creation part
      // save created document in a file
      saveDOMdoc(doc, savefile);
      System.out.println("\nWrote created doc to file " + savefile);
      
      //The BaseURI is the URI that's used to prepend to relative URIs
      String BaseURI = signedFile.toURL().toString();

      //Create an XML Signature object from the document, BaseURI and
      //signature algorithm (in this case DSA)
      XMLSignature sig = new XMLSignature(doc, BaseURI,
                                          XMLSignature.ALGO_ID_SIGNATURE_DSA);

      //Append the signature element to the root element before signing because
      //this is going to be an enveloped signature.
      //This means the signature is going to be enveloped by the document.
      //Two other possible forms are enveloping where the document is inside the
      //signature and detached where they are seperate.
      //Note that they can be mixed in 1 signature with seperate references as
      //shown below.
      root.appendChild(sig.getElement());
      sig.getSignedInfo()
         .addResourceResolver(new org.apache.xml.security.samples.utils.resolver
            .OfflineResolver());

      if (uri2sign != null) 
      {
        //String uri22sign = ""; 
        //String uri22sign = "#incident"; 
        //String uri22sign = "#eventdata"; 
      	//create the transforms object for the Document/Reference
         Transforms transforms = new Transforms(doc);

         //First we have to strip away the signature element (it's not part of the
         //signature calculations). The enveloped transform can be used for this.
         transforms.addTransform(Transforms.TRANSFORM_ENVELOPED_SIGNATURE);
         //Part of the signature element needs to be canonicalized. It is a kind
         //of normalizing algorithm for XML. For more information please take a
         //look at the W3C XML Digital Signature webpage.
         transforms.addTransform(Transforms.TRANSFORM_C14N_WITH_COMMENTS);
         //Add the above Document/Reference
         sig.addDocument(uri2sign, transforms, Constants.ALGO_ID_DIGEST_SHA1);
         //sig.addDocument(uri22sign, transforms, Constants.ALGO_ID_DIGEST_SHA1);
         
      } else
      {
        // sign the message with Subject and no signature
        //String xp1 = "not(ancestor-or-self::ds:Signature)" + "\n"
        //          + "    (ancestor-or-self::node() = /IODEF-Document/Incident)";

        Transforms transforms = new Transforms(doc);
         XPathContainer xpath = new XPathContainer(doc);

         xpath.setXPathNamespaceContext("ds", Constants.SignatureSpecNS);
         xpath.setXPath("\n" + xpath2sign + "\n");
         transforms.addTransform(Transforms.TRANSFORM_XPATH,
                                 xpath.getElementPlusReturns());
         sig.addDocument("", transforms, Constants.ALGO_ID_DIGEST_SHA1);
      }

      {
         //Add in the KeyInfo for the certificate that we used the private key of
         X509Certificate cert =
            (X509Certificate) ks.getCertificate(certificateAlias);

         //System.out.print("\n### X.509 content: \n" + cert.toString()); //***  
         
         sig.addKeyInfo(cert);
         sig.addKeyInfo(cert.getPublicKey());
         System.out.println("Start signing");
         sig.sign(privateKey);
         System.out.println("Finished signing");
      
      }

      FileOutputStream f = new FileOutputStream(signedFile);
      
      XMLUtils.outputDOMc14nWithComments(doc, f);
      f.close();
      System.out.println("Wrote signed document to " + BaseURI);
  	}
	public static PrivateKey getPrivKey (List keyset) throws Exception {

		//List keyset = ConfigSecurity.getConfigSecurity(keyalias);
  	    String keystoreType = (String) keyset.get(0);
  	    String keystoreFile = (String) keyset.get(1);
  	    String keystorePass = (String) keyset.get(2);
  	    String privateKeyAlias = (String) keyset.get(3);
  	    String privateKeyPass = (String) keyset.get(4);
  	    String certificateAlias = (String) keyset.get(5);

        // Retrieving key information
        KeyStore ks = KeyStore.getInstance(keystoreType);
        FileInputStream fis = new FileInputStream(keystoreFile);
        //load the keystore
        ks.load(fis, keystorePass.toCharArray());
        //get the private key for signing.
        PrivateKey privateKey = (PrivateKey) ks.getKey(privateKeyAlias,
                                               privateKeyPass.toCharArray());
         //System.out.print("\n###Private key: \n" + privateKey.toString());
        return privateKey;
	
	} 

 	public static org.w3c.dom.Document readFileToDOM (String filename) throws Exception {
        // start xml document processing part
        javax.xml.parsers.DocumentBuilderFactory dbf =
           javax.xml.parsers.DocumentBuilderFactory.newInstance();

        //XML Signature needs to be namespace aware
        dbf.setNamespaceAware(true);

        javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder();
        //org.w3c.dom.Document docnew = db.newDocument();

        // reading document
        //System.out.print("file to read " + filename + "\n");
        org.w3c.dom.Document doc = db.parse(filename);

        // print echo file after parsing
       	//printDOMdoc(doc);
        return doc;
 	}	
	
 	public static void printKeyInfo (String keyalias) throws Exception {
 	   	List checkconfsec = new ArrayList();

 	   	checkconfsec = ConfigSecurity.getConfigSecurity(keyalias);

 		String keystoreType = (String) checkconfsec.get(0);
 		String keystoreFile = (String) checkconfsec.get(1);
 		String keystorePass = (String) checkconfsec.get(2);
 		String privateKeyAlias = (String) checkconfsec.get(3);
 		String privateKeyPass = (String) checkconfsec.get(4);
 		String certificateAlias = (String) checkconfsec.get(5);
 		//

 		System.out.print ("\n###Echo Key information\n" 
 				+ "keystoreType=" + keystoreType + "\n" 
 				+ "keystoreFile=" + keystoreFile + "\n" 
 				+ "keystorePass=" + keystorePass + "\n"
 				+ "privateKeyAlias=" + privateKeyAlias + "\n"
 				+ "privateKeyPass=" + privateKeyPass + "\n"
 				+ "certificateAlias=" + certificateAlias + "\n\n"); 		
 	}

 	public static void printDOMdoc (org.w3c.dom.Document doc) throws Exception {
        // print DOM doc
        ByteArrayOutputStream f = new ByteArrayOutputStream();
        XMLUtils.outputDOMc14nWithComments(doc, f);
        f.close();
        System.out.println("\n" + f);
 	}
 	
 	public static void saveDOMdoc (org.w3c.dom.Document doc, String filename) throws Exception {
        // save file from DOM doc
        FileOutputStream f = new FileOutputStream(filename);
        XMLUtils.outputDOMc14nWithComments(doc, f);
        f.close();
        //System.out.println("Wrote echo DOM doc to " + filename);
 	}
 	
 	static {
      org.apache.xml.security.Init.init();
   }
   
   /**
    * Method main
    * @param interactive
    * @throws Exception
    */
   public static void main(String args[]) throws Exception {
    Constants.setSignatureSpecNSprefix("ds"); 
    String inputFile = "iodef40test01.xml";

      //Receive parameters for the keystore
  	String keyalias = "iodef04";
   	List checkconfsec = new ArrayList();
   	List keyset = ConfigSecurity.getConfigSecurity(keyalias);
	//printKeyInfo (keyalias); 
   	
   	// uri for signed elements
   	String uri2sign1 = "#incident"; 
   	String uri2sign2 = "#xpointer(id('incident'))";
   	String xpath2sign1 = "not(ancestor-or-self::ds:Signature) \n" +
						"and (ancestor-or-self::node() = /iodef:IODEF-Document/iodef:Incident)";
   	String xpath2sign2 = "not(ancestor-or-self::ds:Signature) \n" +
	"and (ancestor-or-self::node() = /iodef:IODEF-Document/iodef:Incident) and " +
	"(ancestor-or-self::node() = /iodef:IODEF-Document/iodef:Incident/iodef:EventData)";
   	
   	// call methods to read and sign external document

   	try {   	
	System.out.println("Running Examples for XML Signature types for IODEF-Document");
	System.out.println("Select Signature option ( \n" + 
			"0 - Create and sign whole document with an ENVELOPED Signature, e.g. <ds:Reference URI=\"\">\n" + 
			"1 - ENVELOPED for element by Id/ID, e.g. URI=\"#incident\"\n" + 
			"2 - ENVELOPED for element by Id/ID, e.g. URI=\"#xpointer(id('incident'))\"\n" +
			"3 - ENVELOPED for element with XPath TRANSFORM, e.g. \n" +
			"    XPath = not(ancestor-or-self::ds:Signature) \n" +
			"    and (ancestor-or-self::node() = /IODEF-Document/Incident)\n" +
			"4 - ENVELOPED for element with XPath TRANSFORM, e.g. \n" +
			"    XPath = not(ancestor-or-self::ds:Signature) \n" +
			"    and ((ancestor-or-self::node() = /IODEF-Document/Incident)\n" +
			"    or (ancestor-or-self::node() = /IODEF-Document/Incident/EventData))");
	int s = HelpersReadWrite.readStdinInt();			
	switch(s) {
		case 0: {CreateAndSignDoc (keyset, "", null);  return;}
		case 1: {CreateAndSignDoc (keyset, uri2sign1, null);  return;}
		case 2: {CreateAndSignDoc (keyset, uri2sign2, null);  return;}
		case 3: {CreateAndSignDoc (keyset, null, xpath2sign1); return;}
		case 4: {CreateAndSignDoc (keyset, null, xpath2sign2); return;}
	}
	System.out.println("OK");
	System.exit(0);
   	} catch (Exception e) {
   		e.printStackTrace();
   		System.exit(1);
   		}
   }
}
