/*
 * (C) Copyright IBM Corp. 1999-2000  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package xss4jsamples.asn1;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.Window;

/**
  * SplashWindow is the window for a splash window.
  */
public class SplashWindow extends Window {
    Image splashImage; // a splash image
    int x, y; // the width and height of image

    /**
      * Constructs a window for spalsh window.
      *
      * @param <CODE>parent</CODE> - the main application frame.
      * @param <CODE>splashImage</CODE> - a splash image.
      * @param <CODE>x</CODE> - the width of image.
      * @param <CODE>y</CODE> - the height of image.
      */
    public SplashWindow(Frame parent, Image splashImage, int x, int y) {
        super(parent); 

        this.splashImage = splashImage; 
        this.x = x;
        this.y = y;

        setSize(x,y); 

        Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
        Rectangle winDim = getBounds();
        setLocation((screenDim.width - winDim.width) / 2, (screenDim.height - winDim.height) / 2); 

        setVisible(true);
    } 

    /**
      * Draws a splash image.
      */
    public void draw() {
        Graphics g = getGraphics();
        g.drawImage(splashImage, 0, 0, x, y, null);
    }
}
