/*
 * (C) Copyright IBM Corp. 1999,2000,2001  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package xss4jsamples.domhash;

import com.ibm.dom.util.Digest;
import com.ibm.dom.util.StandardErrorHandler;
import java.io.PrintWriter;
import java.security.MessageDigest;
import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Node;

/**
 * Prints a digest value for the root element of specified XML document.
 * 
 * @version $Id: DOMDigestTest.java,v 1.2 2004/04/14 06:41:15 kent Exp $
 * @author TAMURA Kent &lt;kent@trl.ibm.co.jp&gt;
 */
public class DOMDigestTest {
    public static void main(String[] argv) throws Exception {
        DOMParser p = new DOMParser();
        p.setErrorHandler(new StandardErrorHandler());
        p.parse(argv[0]);
        Node node = p.getDocument();

        System.out.print("MD5 digest value of the root element: ");
        System.out.flush();
        byte[] digest = Digest.getDigest(MessageDigest.getInstance("MD5"), node);
        PrintWriter pw = new PrintWriter(System.out);
        Digest.printByteArray(pw, digest);
        pw.close();
    }
}
