/*
 * (C) Copyright IBM Corp. 1999-2001  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package xss4jsamples.enc;

import com.ibm.xml.enc.AlgorithmFactoryExtn;
import com.ibm.xml.enc.DOMSerializationEngine;
import com.ibm.xml.enc.type.EncryptedData;
import com.ibm.xml.enc.util.DOMCanonicalizationEngine;

import java.security.NoSuchAlgorithmException;

/**
 * @version $Id: AlgorithmFactoryWithDOMC14nEngine.java,v 1.2 2002/10/16 08:56:41 imamu Exp $
 * @author Takeshi IMAMURA
 */
public class AlgorithmFactoryWithDOMC14nEngine extends AlgorithmFactoryExtn {
    //
    // Data
    //

    private boolean fWithComments;


    //
    // Methods
    //

    /**
     * @param withComments <code>true</code> if a canonical form
     * contains comments.
     */
    public void setWithComments(boolean withComments) {
	fWithComments = withComments;
    }


    //
    // Methods of class: AlgorithmFactoryExtn
    //

    public DOMSerializationEngine getDOMSerializationEngine(String type)
	throws NoSuchAlgorithmException {

	DOMSerializationEngine engine = null;
	if (type == null) {
	    throw new NullPointerException("Type not specified");

	} else if (type.equals(EncryptedData.ELEMENT)) {
	    engine = new DOMCanonicalizationEngine.XMLElement(fWithComments);

	} else if (type.equals(EncryptedData.CONTENT)) {
	    engine = new DOMCanonicalizationEngine.XMLContent(fWithComments);

	} else {
	    throw new NoSuchAlgorithmException("Unknown type: "+type);
	}

	return engine;
    }
}
